#include "object.h"
Object::Object ()
{

  initialize();

  importFile ("reaphigh.obj");
 

  
  glColor3f(1.0,0,0);
  /*  glBegin(GL_QUADS);
  printf ("face-count %i\n", faces->getCount());
  for (int i=0; i<=faces->getCount();++i)
    {
      glArrayElement((int)faces->getArray()[i] -1);
   }
   glEnd();*/
  finalize();
}

bool Object::importFile (char* fileName)
{
  objFile = fileName;
  this->readFromObjFile (objFile);
  return true;
}

bool Object::initialize (void)
{
  faceMode = -1;
  if ( (listNumber = glGenLists(1)) == 0 )
    {
      printf ("list could not be created for this Object\n");
      return false;
    }
  glNewList (listNumber, GL_COMPILE);
  glEnableClientState (GL_VERTEX_ARRAY);

  return true;
}

bool Object::finalize(void)
{
  glEndList();
  return true;
}

void Object::draw (void)
{
  glCallList (listNumber);

}


bool Object::readFromObjFile (char* fileName)
{
  OBJ_FILE = new ifstream (fileName);
  char Buffer[500];
  vertices = new Array();
  faces = new Array();
  while(!OBJ_FILE->eof())
    {
      OBJ_FILE->getline(Buffer, 500);
      //      printf("%s\n", Buffer);
      

      // case vertice
      if (!strncmp(Buffer, "v ", 2))
	{
	  readVertex(Buffer+2);
	}

      // case face
      else if (!strncmp(Buffer, "f ", 2))
	{
	  readFace (Buffer+2);
	}

      // case vt
      else if (!strncmp(Buffer, "vt ", 2))
      {
	//	printf ("verticeTangent found");
      }
	  

    }
  

  
  OBJ_FILE->close();
  glEnd();
  
}


bool Object::readVertex (char* vertexString)
{
  readVertices = true;
  char subbuffer1[20];
  char subbuffer2[20];
  char subbuffer3[20];
  sscanf (vertexString, "%s %s %s", subbuffer1, subbuffer2, subbuffer3);
  vertices->addEntry(atof(subbuffer1), atof(subbuffer2), atof(subbuffer3));
  return true;
}

bool Object::readFace (char* faceString)
{
  if (readVertices == true)
    {
      vertices->finalizeArray();
      glVertexPointer(3, GL_FLOAT, 0, vertices->getArray());
    }

  readVertices = false;
  char subbuffer1[20];
  char subbuffer2[20];
  char subbuffer3[20];
  char subbuffer4[20] ="";
  sscanf (faceString, "%s %s %s %s", subbuffer1, subbuffer2, subbuffer3, subbuffer4);
  //	  vertices->addEntry(atof(subbuffer1), atof(subbuffer2), atof(subbuffer3));
  if (!strcmp(subbuffer4, ""))
    {
      if (faceMode != 3)
	{
	  if (faceMode != -1)
	    glEnd();
	  glBegin(GL_TRIANGLES);
	}
      
      faceMode = 3;
      //printf ("triag: %s, %s, %s\n", subbuffer1, subbuffer2, subbuffer3);
      addGLElement(subbuffer1);
      addGLElement(subbuffer2);
      addGLElement(subbuffer3);
      return true;
    }
  else
    {
      if (faceMode != 4)
	{
	  if (faceMode != -1)
	    glEnd();
	  glBegin(GL_QUADS);
	}
      faceMode = 4;
      printf ("quad: %s, %s, %s, %s\n", subbuffer1, subbuffer2, subbuffer3, subbuffer4);
      addGLElement(subbuffer1);
      addGLElement(subbuffer2);
      addGLElement(subbuffer3);
      addGLElement(subbuffer4);
      return true;
    }
}

bool Object::addGLElement (char* elementString)
{
  char* pointTo;
  pointTo = strstr (elementString, "/");
  pointTo[0] = '\0';
  printf ("f: %s\n", elementString);
  glArrayElement(atoi(elementString)-1);

}
