#include "windowHandler.h"
#include "array.h"
#include <fstream.h>

class Object
{
 public:
  Object ();
  Object (char* fileName);
  ~Object ();
  
  bool importFile (char* fileName);
  bool initialize (void);
  bool finalize(void);
  void draw (void);

  bool readFromObjFile (char* fileName);


 private:
  GLuint listNumber;
  Array* vertices;
  int verticesCount;
  Array* colors;
  Array* faces;
  char* objFile;
  int faceMode;
  bool readVertices;

  ifstream* OBJ_FILE;
  ifstream* MTL_FILE;
  
  bool readVertex (char* vertexString);
  bool readFace (char* faceString);
  bool readVT (char* vtString);

  bool addGLElement (char* elementString);
};
